/*This file is automatically generated by pkg.deepin.io/dbus-generator. Don't edit it*/
package networkmanager
import "pkg.deepin.io/lib/dbus"
import "pkg.deepin.io/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"
/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type VPNConnection struct {
	Path dbus.ObjectPath
	DestName string
	core *dbus.Object

	signals map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	
	VpnState *dbusPropertyVPNConnectionVpnState
	Banner *dbusPropertyVPNConnectionBanner
}

func (obj *VPNConnection) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *VPNConnection) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyVPNConnection(obj *VPNConnection) {
	obj.signalsLocker.Lock()
	defer obj.signalsLocker.Unlock()
	if obj.signals == nil {
		return
	}
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signals = nil

	runtime.SetFinalizer(obj, nil)

	dbusRemoveMatch("type='signal',path='"+string(obj.Path)+"',interface='org.freedesktop.DBus.Properties',sender='"+obj.DestName+"',member='PropertiesChanged'")
	dbusRemoveMatch("type='signal',path='"+string(obj.Path)+"',interface='org.freedesktop.NetworkManager.VPN.Connection',sender='"+obj.DestName+"',member='PropertiesChanged'")

	dbusRemoveMatch("type='signal',path='"+string(obj.Path)+"',interface='org.freedesktop.NetworkManager.VPN.Connection',sender='"+obj.DestName+"',member='PropertiesChanged'")

	dbusRemoveMatch("type='signal',path='"+string(obj.Path)+"',interface='org.freedesktop.NetworkManager.VPN.Connection',sender='"+obj.DestName+"',member='VpnStateChanged'")

	
	obj.VpnState.Reset()
	obj.Banner.Reset()
}






func (obj *VPNConnection) ConnectPropertiesChanged(callback func(properties map[string]dbus.Variant)) func() {
	sigChan := obj._createSignalChan()
	go func() {
		for v := range(sigChan) {
			if v.Path != obj.Path || v.Name != "org.freedesktop.NetworkManager.VPN.Connection.PropertiesChanged" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*map[string]dbus.Variant)(nil)).Elem() {
				continue
			}
			

			callback(v.Body[0].(map[string]dbus.Variant))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

func (obj *VPNConnection) ConnectVpnStateChanged(callback func(state uint32,reason uint32)) func() {
	sigChan := obj._createSignalChan()
	go func() {
		for v := range(sigChan) {
			if v.Path != obj.Path || v.Name != "org.freedesktop.NetworkManager.VPN.Connection.VpnStateChanged" || 2 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*uint32)(nil)).Elem() {
				continue
			}
			if reflect.TypeOf(v.Body[1]) != reflect.TypeOf((*uint32)(nil)).Elem() {
				continue
			}
			

			callback(v.Body[0].(uint32),v.Body[1].(uint32))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}



type dbusPropertyVPNConnectionVpnState struct{
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyVPNConnectionVpnState) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.VPN.Connection.VpnState is not writable")
}

func (this *dbusPropertyVPNConnectionVpnState) Get() uint32 {
	v, _ := this.GetValue()
	return v.(uint32)
}
func (this *dbusPropertyVPNConnectionVpnState) GetValue() (interface{} /*uint32*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.VPN.Connection", "VpnState").Store(&r)
	if err == nil && r.Signature().String() == "u" { 
		return r.Value().(uint32), nil
	}
	return *new(uint32), err
}
func (this *dbusPropertyVPNConnectionVpnState) GetType() reflect.Type {
	return reflect.TypeOf((*uint32)(nil)).Elem()
}

type dbusPropertyVPNConnectionBanner struct{
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyVPNConnectionBanner) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.VPN.Connection.Banner is not writable")
}

func (this *dbusPropertyVPNConnectionBanner) Get() string {
	v, _ := this.GetValue()
	return v.(string)
}
func (this *dbusPropertyVPNConnectionBanner) GetValue() (interface{} /*string*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.VPN.Connection", "Banner").Store(&r)
	if err == nil && r.Signature().String() == "s" { 
		return r.Value().(string), nil
	}
	return *new(string), err
}
func (this *dbusPropertyVPNConnectionBanner) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}


func NewVPNConnection(destName string, path dbus.ObjectPath) (*VPNConnection, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &VPNConnection{Path:path, DestName:destName, core:core,signals:make(map[<-chan *dbus.Signal]struct{})}
	
	obj.VpnState = &dbusPropertyVPNConnectionVpnState{&property.BaseObserver{}, core}
	obj.Banner = &dbusPropertyVPNConnectionBanner{&property.BaseObserver{}, core}

	dbusAddMatch("type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	dbusAddMatch("type='signal',path='"+string(path)+"',interface='org.freedesktop.NetworkManager.VPN.Connection',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range(sigChan) {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "org.freedesktop.NetworkManager.VPN.Connection" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false { 
					} else if key == "VpnState" {
						obj.VpnState.Notify()
					
					} else if key == "Banner" {
						obj.Banner.Notify()
					 }
				}
			} else if v.Name == "org.freedesktop.NetworkManager.VPN.Connection.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false { 
					} else if key == "VpnState" {
						obj.VpnState.Notify()
					
					} else if key == "Banner" {
						obj.Banner.Notify()
					 }
				}
			}
		}
	}()


	dbusAddMatch("type='signal',path='"+string(obj.Path)+"',interface='org.freedesktop.NetworkManager.VPN.Connection',sender='"+obj.DestName+"',member='PropertiesChanged'")

	dbusAddMatch("type='signal',path='"+string(obj.Path)+"',interface='org.freedesktop.NetworkManager.VPN.Connection',sender='"+obj.DestName+"',member='VpnStateChanged'")

runtime.SetFinalizer(obj, func(_obj *VPNConnection) { DestroyVPNConnection(_obj) })
	return obj, nil
}

