/*This file is automatically generated by pkg.deepin.io/dbus-generator. Don't edit it*/
package udisks2
import "pkg.deepin.io/lib/dbus"
import "pkg.deepin.io/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"
/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type Loop struct {
	Path dbus.ObjectPath
	DestName string
	core *dbus.Object

	signals map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	
	BackingFile *dbusPropertyLoopBackingFile
	Autoclear *dbusPropertyLoopAutoclear
	SetupByUID *dbusPropertyLoopSetupByUID
}

func (obj *Loop) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *Loop) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyLoop(obj *Loop) {
	obj.signalsLocker.Lock()
	defer obj.signalsLocker.Unlock()
	if obj.signals == nil {
		return
	}
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signals = nil

	runtime.SetFinalizer(obj, nil)

	dbusRemoveMatch("type='signal',path='"+string(obj.Path)+"',interface='org.freedesktop.DBus.Properties',sender='"+obj.DestName+"',member='PropertiesChanged'")
	dbusRemoveMatch("type='signal',path='"+string(obj.Path)+"',interface='org.freedesktop.UDisks2.Loop',sender='"+obj.DestName+"',member='PropertiesChanged'")

	
	obj.BackingFile.Reset()
	obj.Autoclear.Reset()
	obj.SetupByUID.Reset()
}




func (obj *Loop) Delete (options map[string]dbus.Variant) ( _err error) {
	_err = obj.core.Call("org.freedesktop.UDisks2.Loop.Delete", 0, options).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Loop) SetAutoclear (value bool,options map[string]dbus.Variant) ( _err error) {
	_err = obj.core.Call("org.freedesktop.UDisks2.Loop.SetAutoclear", 0, value, options).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}





type dbusPropertyLoopBackingFile struct{
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyLoopBackingFile) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.UDisks2.Loop.BackingFile is not writable")
}

func (this *dbusPropertyLoopBackingFile) Get() []uint8 {
	v, _ := this.GetValue()
	return v.([]uint8)
}
func (this *dbusPropertyLoopBackingFile) GetValue() (interface{} /*[]uint8*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.UDisks2.Loop", "BackingFile").Store(&r)
	if err == nil && r.Signature().String() == "ay" { 
		return r.Value().([]uint8), nil
	}
	return *new([]uint8), err
}
func (this *dbusPropertyLoopBackingFile) GetType() reflect.Type {
	return reflect.TypeOf((*[]uint8)(nil)).Elem()
}

type dbusPropertyLoopAutoclear struct{
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyLoopAutoclear) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.UDisks2.Loop.Autoclear is not writable")
}

func (this *dbusPropertyLoopAutoclear) Get() bool {
	v, _ := this.GetValue()
	return v.(bool)
}
func (this *dbusPropertyLoopAutoclear) GetValue() (interface{} /*bool*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.UDisks2.Loop", "Autoclear").Store(&r)
	if err == nil && r.Signature().String() == "b" { 
		return r.Value().(bool), nil
	}
	return *new(bool), err
}
func (this *dbusPropertyLoopAutoclear) GetType() reflect.Type {
	return reflect.TypeOf((*bool)(nil)).Elem()
}

type dbusPropertyLoopSetupByUID struct{
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyLoopSetupByUID) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.UDisks2.Loop.SetupByUID is not writable")
}

func (this *dbusPropertyLoopSetupByUID) Get() uint32 {
	v, _ := this.GetValue()
	return v.(uint32)
}
func (this *dbusPropertyLoopSetupByUID) GetValue() (interface{} /*uint32*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.UDisks2.Loop", "SetupByUID").Store(&r)
	if err == nil && r.Signature().String() == "u" { 
		return r.Value().(uint32), nil
	}
	return *new(uint32), err
}
func (this *dbusPropertyLoopSetupByUID) GetType() reflect.Type {
	return reflect.TypeOf((*uint32)(nil)).Elem()
}


func NewLoop(destName string, path dbus.ObjectPath) (*Loop, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &Loop{Path:path, DestName:destName, core:core,signals:make(map[<-chan *dbus.Signal]struct{})}
	
	obj.BackingFile = &dbusPropertyLoopBackingFile{&property.BaseObserver{}, core}
	obj.Autoclear = &dbusPropertyLoopAutoclear{&property.BaseObserver{}, core}
	obj.SetupByUID = &dbusPropertyLoopSetupByUID{&property.BaseObserver{}, core}

	dbusAddMatch("type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	dbusAddMatch("type='signal',path='"+string(path)+"',interface='org.freedesktop.UDisks2.Loop',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range(sigChan) {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "org.freedesktop.UDisks2.Loop" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false { 
					} else if key == "BackingFile" {
						obj.BackingFile.Notify()
					
					} else if key == "Autoclear" {
						obj.Autoclear.Notify()
					
					} else if key == "SetupByUID" {
						obj.SetupByUID.Notify()
					 }
				}
			} else if v.Name == "org.freedesktop.UDisks2.Loop.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false { 
					} else if key == "BackingFile" {
						obj.BackingFile.Notify()
					
					} else if key == "Autoclear" {
						obj.Autoclear.Notify()
					
					} else if key == "SetupByUID" {
						obj.SetupByUID.Notify()
					 }
				}
			}
		}
	}()


runtime.SetFinalizer(obj, func(_obj *Loop) { DestroyLoop(_obj) })
	return obj, nil
}

